#!/usr/bin/python3
# -*- coding: utf-8 -*-
#
"""

tkQRcode3.py for python3

Version: 001

Date: 2023-04-17, W. Spiegel

Vers. 001: Start

Vers. 002: simple error handling


This script is using pypng and pyqrcode to generate a QR-code as a png-Image

https://colorpicker.me/


"""
#####################################################

_prg_ = "tkQRcode3"  # python3-Version

_ver_ = "002"

_date_ = "2023-04-17"

import os.path
import sys
import os, struct, json
import subprocess,time,string,codecs
import webbrowser
import fileinput
import png
import pyqrcode

_tkFlag_ = 1

root = None

try:
    from tkinter import *
    import tkinter.messagebox
    from tkinter.filedialog import *
    from tkinter.colorchooser import askcolor
except:
    _tkFlag_ = 0

    
def ausgabe(titel, text,_end_=False):   
    'Aufruf: ausgabe(text) bzw. ausgabe(text,t1)'
    if _end_:
        main = Tk() 
        main.withdraw()     
        tkinter.messagebox.showinfo(titel, text)
        #tkinter.messagebox
        main.quit()
    else:
        tkinter.messagebox.showinfo(titel, text)


##def ausgabe(titel, text):   
##    'Aufruf: ausgabe(text) bzw. ausgabe(text,t1)'
##    tkMessageBox.showinfo(titel, text)    
###################################

    

_toc_flag_ = 0

ret_toc  = None

ret_table = None

# "README.md"

#_testenFlag_ = True
_testenFlag_ = False





_idle_= 0


#####################################################
def beenden():
    if _tkFlag_:
        root.destroy()
        
    if not _idle_:
        import sys
        sys.exit(0)

def hilfe():  
    readme_doc = os.path.abspath( os.getcwd() ) + os.sep + 'docu' + os.sep +  "index.html"
    webbrowser.open(readme_doc)

    

def takeOver():
    tmp = eingabe1.get()
    neuer_name = os.path.splitext(tmp)[0] + ".pdf"
    # ausgabe("takeOver",neuer_name)
    eingabe3.delete(0, END)
    eingabe3.insert(END,neuer_name)


def holeDateiname(choosed_entry,mode=1):    
    start_pfad = os.path.abspath (os.getcwd()) + os.sep        
    # multiple types in  askopenfilename via a tupel, see "html-Files" 
    if (mode==1): # png
	    eingabe = askopenfilename(title='Datei',filetypes=[("png-Files","*.png"),("Alle Dateien","*.*")],initialdir=start_pfad)
    elif (mode==2): # md
	    eingabe = askopenfilename(title='Datei',filetypes=[("md-Files","*.md"),("html-Files",("*.html","*.htm")),("css-Files","*.css"),("txt-Files","*.txt"),("Alle Dateien","*.*")],initialdir=start_pfad)	
    elif (mode==3): # css		
	    eingabe = askopenfilename(title='Datei',filetypes=[("css-Files","*.css"),("md-Files","*.md"),("html-Files",("*.html","*.htm")),("css-Files","*.css"),("txt-Files","*.txt"),("Alle Dateien","*.*")],initialdir=start_pfad+'themes'+os.sep )		
    else:  # Default: png
	    eingabe = askopenfilename(title='Datei',filetypes=[("png-Files","*.png"),("Alle Dateien","*.*")],initialdir=start_pfad)	
    if eingabe != '': 
        dateiname  = os.path.abspath (eingabe)        
        choosed_entry.delete(0,END)         
        choosed_entry.insert(END, dateiname)

def getDir():
    import tkinter.filedialog
    _dir_ = tkinter.filedialog.askdirectory()
    eingabe2.delete(0,END)         
    eingabe2.insert(END, _dir_)


def getColor():
    from math import trunc
        
    colors = askcolor(title="Tkinter Color Chooser")

    try:
        red_=trunc(colors[0][0])
        green_=trunc(colors[0][1])
        blue_=trunc(colors[0][2])
        
        # foreground
        eingabe7.delete(0,END)
        eingabe8.delete(0,END)
        eingabe9.delete(0,END)

        # foreground
        eingabe7.insert(0,red_)
        eingabe8.insert(0,green_)
        eingabe9.insert(0,blue_)
    except:
        None

def callTest(val):
    ival = int(val)
    if (ival < 0):
        ival = testValue(ival, False)
    elif (ival > 255):
        ival = testValue(ival, True)
    return str(ival)
    

def testValue(val, lt):
    if lt and (val > 255):
        return 255
    elif (not lt) and (val < 0):
        return 0
    else:
        return val

def qrCode():
    """
    grey = [99,99,99,255]

    green = [50,220,180,255]    

    blue = [15,88,199,255] 

    yellow = [250,250,5,255]
    """
    

    _ok_ = False
    
    # set the pyqrcode-values
    _msg_ = eingabe1.get()

    _file_name_ = eingabe3.get()
    
    _size_ = eingabe2.get()

    _op_ = callTest( eingabe6.get() )

    _red_ =  callTest( eingabe7.get() )
    _green_ =  callTest( eingabe8.get() )
    _blue_ =  callTest( eingabe9.get() )

    bgRed =  callTest( eingabe11.get() )
    bgGreen =  callTest( eingabe12.get() )
    bgBlue =  callTest( eingabe13.get() )
    
    _farbe_ = [_red_,_green_,_blue_,_op_]  # black = [0,0,0,255]
    _bg_farbe_ = [bgRed, bgGreen, bgBlue]  # white = [0xff, 0xff, 0xff]
    
    # generate QR-Code

    qr = pyqrcode.create(_msg_)
    
    qr.png(_file_name_, scale=_size_, module_color=_farbe_, background=_bg_farbe_)

    delInput()

    # Background
    eingabe11.insert(0,bgRed)
    eingabe12.insert(0,bgGreen)
    eingabe13.insert(0,bgBlue)
    

    eingabe6.insert(0,_op_)  # op

    # foreground
    eingabe7.insert(0,_red_)
    eingabe8.insert(0,_green_)
    eingabe9.insert(0,_blue_)

    
def delInput():
    # Background
    eingabe11.delete(0,END)
    eingabe12.delete(0,END)
    eingabe13.delete(0,END)

    #eingabe3.delete(0,END)  # filename    
    #eingabe2.delete(0,END)  # size
    eingabe6.delete(0,END)  # op


    # foreground
    eingabe7.delete(0,END)
    eingabe8.delete(0,END)
    eingabe9.delete(0,END)  


def init():

    #eingabe3.delete(0,END)  # filename    
    eingabe2.delete(0,END)  # size    

    delInput()  
    
    # Background
    eingabe11.insert(0,0xff)
    eingabe12.insert(0,0xff)
    eingabe13.insert(0,0xff)
    
    eingabe2.insert(0,'10')   # size
    eingabe6.insert(0,'255')  # op

    # foreground
    eingabe7.insert(0,'0')
    eingabe8.insert(0,'0')
    eingabe9.insert(0,'0')    


    


      
#######################################################
#######################################################        
# main   
if __name__ == "__main__":   
    if _tkFlag_:
        _debug_ = 0

        # set the pyqrcode-values
        _msg_ = "http://nawi.wspnet.de/#!index.md"
        _size_ = 10
        _op_ = 250
        _farbe_ = [0,0,0,_op_]  # black
        _bg_farbe_ = [0xff, 0xff, 0xff]  # white
        _file_name_ = "qr-code-example.png"

        
        root=Tk()
        root.withdraw()        
        root.title(_prg_ + ", Vers. " + _ver_)

        foben = Frame(root)
        foben.pack(expand=YES, fill=BOTH)  

        lab1=Label(foben,text="msg2QR: ")
        lab1.grid(row=1,column=0)
        eingabe1 = Entry(foben,width=84)             ## Eingabezeile erzeugen
        eingabe1.grid(row=1,column=1,columnspan=2)
        #eingabe1.insert(END,'in.md')
        eingabe1.insert(END,_msg_)
        #eingabe1.insert(END,'/home/walter/py_prg/md2tabs/md2tabs_vers001/ppp_schwingungsgleichung.md')
      
        lab3=Label(foben,text="png-File: ")
        lab3.grid(row=3,column=0)
        eingabe3 = Entry(foben,width=73)             ## Eingabezeile erzeugen
        eingabe3.grid(row=3,column=1)
        eingabe3.insert(END,'./'+_file_name_)
        fileButton3 = Button(foben,text=" _open_ ",bd="1",command=(lambda arg=eingabe3: holeDateiname(arg,1) )  )
        fileButton3.grid(row=3,column=2)
        
        fmitte = Frame(root)
        fmitte.pack(expand=YES, fill=BOTH,ipady=10)


        lab2=Label(fmitte,text="size:  ")
        lab2.pack(side=LEFT)
        eingabe2 = Entry(fmitte,width=3)             ## Eingabezeile erzeugen
        eingabe2.pack(side=LEFT)
        eingabe2.insert(END,'10')

        lab6=Label(fmitte,text=" | opacity: ")
        lab6.pack(side=LEFT)
        eingabe6 = Entry(fmitte,width=3)             ## Eingabezeile erzeugen
        eingabe6.pack(side=LEFT)
        eingabe6.insert(END,'255')

        lab7=Label(fmitte,text=" | red:   ")
        lab7.pack(side=LEFT)
        eingabe7 = Entry(fmitte,width=3)             ## Eingabezeile erzeugen
        eingabe7.pack(side=LEFT)
        eingabe7.insert(END,'0')

        lab8=Label(fmitte,text="green: ")
        lab8.pack(side=LEFT)
        eingabe8 = Entry(fmitte,width=3)             ## Eingabezeile erzeugen
        eingabe8.pack(side=LEFT)
        eingabe8.insert(END,'0')

        lab9=Label(fmitte,text="blue:  ")
        lab9.pack(side=LEFT)
        eingabe9 = Entry(fmitte,width=3)             ## Eingabezeile erzeugen
        eingabe9.pack(side=LEFT)
        eingabe9.insert(END,'0')        
        


        lab11=Label(fmitte,text=" | bgRed:  ")
        lab11.pack(side=LEFT)
        eingabe11 = Entry(fmitte,width=4)             ## Eingabezeile erzeugen
        eingabe11.pack(side=LEFT)
        eingabe11.insert(END,0xff)

        lab12=Label(fmitte,text="bgGreen: ")
        lab12.pack(side=LEFT)
        eingabe12 = Entry(fmitte,width=4)             ## Eingabezeile erzeugen
        eingabe12.pack(side=LEFT)
        eingabe12.insert(END,0xff)

        lab13=Label(fmitte,text="bgBlue: ")
        lab13.pack(side=LEFT)
        eingabe13 = Entry(fmitte,width=4)             ## Eingabezeile erzeugen
        eingabe13.pack(side=LEFT)
        eingabe13.insert(END,0xff)

        
        funten = Frame(root)
        funten.pack(expand=YES, fill=BOTH)
        qrBut=Button(funten,text="_QR_",command=qrCode)
        qrBut.pack(side=LEFT,fill=X,expand=YES)


        colbut=Button(funten,text="Color-Chooser",command=getColor)
        colbut.pack(side=LEFT,fill=X,expand=YES)

        
        initbut=Button(funten,text="_init_",command=init)
        initbut.pack(side=LEFT,fill=X,expand=YES)
        
        helpbut=Button(funten,text="Help",command=hilfe)
        helpbut.pack(side=LEFT,fill=X,expand=YES)

        endbut=Button(funten,text="Exit",command=beenden)
        endbut.pack(side=RIGHT,fill=X,expand=YES)      
        funten2 = Frame(root)
        funten2.pack(expand=YES, fill=BOTH)
        lab4var = StringVar()
        lab4=Label(funten2,textvariable=lab4var,font=("Helvetica", 8),anchor=W )
        lab4.pack(fill=X,expand=YES)

        root.deiconify()  # Unhide split-pdf3.py                          
        root.mainloop()
    else:
        print(">>> No TKinter installed!\n\n\t tkQRcode3.py will not work. Sorry!")

