#!/usr/bin/python
# -*- coding: utf-8 -*-
 
"""
  tkSourceParser.pyw: Python Source Parser
  MoinMoin - Python Source Parser by Jürgen Hermann
  Quelle: http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/52298
  Original: http://moinmoin.wikiwikiweb.de/
  
  2005-04-03, Vers. 0.06, WS
  0.06: Tkinter-Version
        schreibt die HTML-Datei mit File-Handle
  2006-07-08, Vers. 0.07, WS
  0.07: schreibt Datum in Header
  2023-07-24, Vers. 0.08a, sp
  0.08a: Angepasst an utf-8 und den Python-Kurs
  2023-07-26, Vers. 0.09a, sp
  0.09a: Angepasst an den Python-Kurs; Button "Anzeigen" > "ALLE"

  Anpassung an den Python-Kurs
  # statt   schreibeRumpf( filehandle ,rumpf)
  >>> schreibeRumpf( filehandle , fenster_pykurs+rumpf)  # fuer Python-Kurs  
"""

# Imports
import sys,os,time  
from os.path import abspath,exists
#import Tkinter
from Tkinter import *

if os.name == 'posix':
    wantobjects = 0
    # tkMessageBox.askyesno wrong result under Linux!
    # see http://mail.python.org/pipermail/python-bugs-list/2004-September/025172.html
    
import tkMessageBox   
from ScrolledText import *
from tkFileDialog import *
import cgi, string, cStringIO
import keyword, token, tokenize
#############################
idle = 0

__version__ = '0.09a'  # tkSourceParser-Version 

pgdate = '2023-07-26'
pgname = 'tkSourceParser'  
tl=[]   
root = None #Tk()   
t2=None

pfad = os.getcwd()

htmlfile= "test.htm"
css_flag = 1
if css_flag: # Default-Einstellung
    css_file="source_parser.css"
else:       # Einstellung fuer ws-homepage
    css_file="my_style.css"



hilfetext="""\n\t\ttkSourceParser, Vers. %s  
\ntkSourceParser erstellt aus einer Python-Datei
eine HTML-Datei.
""" % __version__
#############################
def die():
    if tkMessageBox.askyesno("Beenden?",pgname + " beenden?"):
        die_()

def die_():        
   if os.name == 'posix':  
       root.quit()  
   else:	 	  
       root.destroy()
       if (not idle):
           sys.exit(0)     
   
def about():   
   tkMessageBox.showinfo("Info",  
     pgname + " by Walter Spiegel\n"
     "Python Source Parser by J. Hermann\n"
     "http://moinmoin.wikiwikiweb.de/\n"
     "Kontakt: walter.spiegel@web.de\n"                          
     "Version " + __version__ + ", " + pgdate)

##############################

def schreibeKopf(datei,mode,text):
    """Oeffnet 'datei' im Modus 'mode' und schreibt 'text' in die Datei.
       gibt Fild-Handle zurueck
    """
    try:
        out_file = open(datei,mode)  # Datei öffnen
        out_file.write(text) # text in Datei schreiben
        return out_file
        #out_file.close()    # Datei schliessen        
    except IOError: # EA-Fehler
        print 'Konnte Datei ' + datei + ' nicht oeffnen!'

def schreibeRumpf(handle,text):
    """Schreibt ueber Dateihandle und schliesst 'datei'"""
    try:
        
        handle.write(text) # text in Datei schreiben
        handle.close()    # Datei schliessen        
    except IOError: # EA-Fehler
        print 'Konnte nicht auf Dateihandle ' + handle + ' zugreifen!'        

def py2html(fileName,pfad,extension):
     """py2html erzeugt aus der Python-Datei die HTML-Datei
        Aufruf: py2html(_fileName_,pfad,extension)
        Version mit File-Handle
     """
     global htmlfile, css_file
     ###############          
     pyfile= fileName + extension

     html_ex = ".htm"  # oder ".html"
     
     htmlfile= fileName + html_ex 
     ####################
     generated_by = '<!--  generated by tkSourceParser.pyw   -->' 
     zeit = time.asctime(time.localtime(time.time())) 
     zeit = '<!--  at ' + zeit + '       -->' 
     generated_by = generated_by + '\n' + zeit
     #print generated_by
     ####################
     kopf = """<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">

%s

<link rel="stylesheet" type="text/css" href="%s">

<title>%s</title>
</head>
<body text="navy" bgcolor="#ffffff">
<h2 class="blau">%s</h2>
""" % (generated_by,css_file,pyfile,pyfile)
     ################
     rumpf="""
</body>
</html>
     """
     fenster_pykurs="""     
<hr>   <!-- py-Kurs -->
&rarr; <a href="javascript:window.close();">Fenster schlie&szlig;en</a>
<hr>   <!-- py-Kurs -->
     """
     
     # open source
     source = open(pfad + pyfile).read()
     
     filehandle = schreibeKopf(pfad + htmlfile,"w",kopf)
     
     # write colorized version to htmlfile=>filehandle
     # Aufruf: Parser(quelle,ziel).format(None, None)
     Parser(source, filehandle ).format(None, None)
     
     # schreibeRumpf( filehandle ,rumpf)
     schreibeRumpf( filehandle , fenster_pykurs+rumpf)  # fuer Python-Kurs
#############################################################################     
"""
 MoinMoin - Python Source Parser
 Quelle: http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/52298
 Original: http://moin.sourceforge.net/
           http://moinmoin.wikiwikiweb.de/
"""    
#############################################################################
### Python Source Parser (does Hilighting)
#############################################################################


_KEYWORD = token.NT_OFFSET + 1
_TEXT    = token.NT_OFFSET + 2

_colors = {
 token.NUMBER:       '#0080C0',
 token.OP:           '#0000C0',
 token.STRING:       '#D649D6',
 tokenize.COMMENT:   '#008000',
 token.NAME:         '#000000',
 token.ERRORTOKEN:   '#FF8080',
 _KEYWORD:           '#C00000',
 _TEXT:              '#000000',
}


class Parser:
 """ Send colored python source.
 """

 def __init__(self, raw, out = sys.stdout):
     """ Store the source text.
     """
     self.raw = string.strip(string.expandtabs(raw))
     self.out = out

 def format(self, formatter, form):
     """ Parse and send the colored source.
     """
     # store line offsets in self.lines
     self.lines = [0, 0]
     pos = 0
     while 1:
         pos = string.find(self.raw, '\n', pos) + 1
         if not pos: break
         self.lines.append(pos)
     self.lines.append(len(self.raw))

     # parse the source and write it
     self.pos = 0
     text = cStringIO.StringIO(self.raw)
     self.out.write('<pre><font face="Lucida,Courier New">')
     try:
         tokenize.tokenize(text.readline, self)
     except tokenize.TokenError, ex:
         msg = ex[0]
         line = ex[1][0]
         self.out.write("<h3>ERROR: %s</h3>%s\n" % (
             msg, self.raw[self.lines[line]:]))
     self.out.write('</font></pre>')

 def __call__(self, toktype, toktext, (srow,scol), (erow,ecol), line):
     """ Token handler.
     """
     if 0:
         print "type", toktype, token.tok_name[toktype], "text", toktext,
         print "start", srow,scol, "end", erow,ecol, "<br>"

     # calculate new positions
     oldpos = self.pos
     newpos = self.lines[srow] + scol
     self.pos = newpos + len(toktext)

     # handle newlines
     if toktype in [token.NEWLINE, tokenize.NL]:
         self.out.write('\n')
         return

     # send the original whitespace, if needed
     if newpos > oldpos:
         self.out.write(self.raw[oldpos:newpos])

     # skip indenting tokens
     if toktype in [token.INDENT, token.DEDENT]:
         self.pos = newpos
         return

     # map token type to a color group
     if token.LPAR <= toktype and toktype <= token.OP:
         toktype = token.OP
     elif toktype == token.NAME and keyword.iskeyword(toktext):
         toktype = _KEYWORD
     color = _colors.get(toktype, _colors[_TEXT])

     style = ''
     if toktype == token.ERRORTOKEN:
         style = ' style="border: solid 1.5pt #FF0000;"'

     # send text
     self.out.write('<font color="%s"%s>' % (color, style))
     self.out.write(cgi.escape(toktext))
     self.out.write('</font>')


#################################     
class tkSourceParser:   
    def __init__(self, rt):   
        global t2, pgname   
        if rt == None:   
            self.t = Tk()   
        else:   
            self.t = Toplevel(rt)   
        self.t.title(pgname+',  '+__version__ )    #  

   
        self.f = Frame(self.t,width=1000)   
        self.f.pack(expand=1, fill=BOTH)   
         
        self.midfr = Frame(self.f,relief=RIDGE,background="white")   
        self.midfr.pack(side=TOP,fill=BOTH,expand=0)   

        self.butt9=Button(self.midfr,text="Clear",command=self.cl_unten)   
        self.butt9.pack(side=LEFT,fill=BOTH,expand=1)   

        self.butt5=Button(self.midfr,text="py2HTML",command=self.openfile)   
        self.butt5.pack(side=LEFT,fill=BOTH,expand=1)                   

        self.butt2=Button(self.midfr,text="Über...",command=about)   
        self.butt2.pack(side=LEFT,fill=BOTH,expand=1)
        
                  


##        self.butt4=Button(self.midfr,text="Hilfe",command=self.hilfe)   
##        self.butt4.pack(side=LEFT,fill=BOTH,expand=1)                   
   
        self.butt6=Button(self.midfr,text="ALLE *.py",command=self.alle)   
        self.butt6.pack(side=LEFT,fill=BOTH,expand=1)   
               
        self.butt3=Button(self.midfr,text="Ende",command=self.beenden)   
        self.butt3.pack(side=RIGHT,fill=BOTH,expand=1)   
         
        if os.name == 'posix': 
            self.font_size = 11
            self.font_type = 'fixed'            
        else:                 
            self.font_size = 11
            self.font_type = 'courier'

        t2 = ScrolledText(self.f,width=80,height=25,relief=RAISED,font=(self.font_type,self.font_size,'normal'),bd=2,background="white")   
        t2.pack(fill=BOTH, expand=1)   
   
   
    def feedback(self,nachricht):           
        t2.insert(END,nachricht+'\n')   
        t2.see(END)   
        t2.focus_set() # funktioniert!

    def hilfe(self):        
        ausgabe = hilfetext
        self.feedback(ausgabe)


    def alle(self):
        global pfad        
        pyex = ['py','pyw']
        #_pfad_ = pfad
        dirList=os.listdir(pfad)
        for datei in dirList:
            filename = datei.split('.')
            #print filename
            if (len(filename) > 1) and (filename[1] in pyex):  # python-Dateien im Verzeichnis; "(len(filename) > 1)" wg. Unterverzeichnissen!
                # print datei
                filename = datei.split('.')
                py2html( filename[0], pfad+os.sep,  '.'+filename[1] )
                ausgabe = 'Python-Datei "%s" > HTML-Datei "%s.htm"\n' % (filename,filename[0])
                self.feedback( ausgabe )
                #time.sleep(1)
        t2.focus_set()        
            
            

    
    def openfile(self): 
        global pfad 
        debug = 0
        oname = askopenfilename(filetypes=[("Python-Datei", "*.py *.pyw "),("Alle Dateien","*")],initialdir=pfad) 
        if oname: 
            oname = os.path.abspath(oname)
            pfad = os.path.dirname(oname)
            pfad = pfad + os.sep
            datei = os.path.basename(oname)
            liste = os.path.splitext(datei)
            _fileName_ = liste[0] # Dateiname ohne Extension
            extension = liste[1]
            py2html(_fileName_,pfad,extension)
            ausgabe = 'Python-Datei "%s" > HTML-Datei "%s.htm"\n' % (datei,_fileName_)
            self.feedback( ausgabe )
            if debug: 
                #print oname
                self.feedback(pfad + "   \n" + datei + "   \n" + _fileName_ )
            t2.focus_set() 
            
            
    def cl_unten(self):
        global t2
        t2.delete(1.0, END)
   

    def beenden(self):   
        die()

##################################################
def main():
    global root, tl
    pfad = os.getcwd()  
    pfad = os.path.abspath (os.getcwd()) + os.sep
    #ini_pfad = pfad
    #print pgname + ': ' + pfad    
    
    root = None   
    tl.append(tkSourceParser(root))   
    root = tl[0].t   
    root.protocol('WM_DELETE_WINDOW',die)
    
    if (not idle):
        root.mainloop()
    
  
if __name__ == "__main__":
    main()
